/*
 * Project name:
     Led_Blinking (The simplest simple example)
 * Copyright:
     (c) mikroElektronika, 2011.
 * Revision History:
     20110202:
       - Initial release (SZ);
 * Description:
     Simple "Hello world" example for the world of dsPIC MCUs;
 * Test configuration:
     MCU:             PIC24FJ16KA102
                      http://ww1.microchip.com/downloads/en/DeviceDoc/PIC24F16KA102_Family_datasheet_39927b.pdf
     Dev.Board:       Easy24-33 v6
                      http://www.mikroe.com/eng/products/view/494/easy24-33-v6-development-system/
     Oscillator:      HS, 8.00000 MHz
     Ext. Modules:    None.
     SW:              mikroC PRO for dsPIC30/33 and PIC24
                      http://www.mikroe.com/eng/products/view/231/mikroc-pro-for-dspic30-33-and-pic24/
 * NOTES:
     - Turn ON all PORT LEDs at SW4.
 */
 
void main() {

  AD1PCFG = 0x1C3F;      // Configure AN pins as digital I/O
  TRISA = 0;             // Initialize PORTA as output
  TRISB = 0;             // Initialize PORTB as output

  LATA = 0;              // Set PORTA to zero
  LATB = 0;              // Set PORTB to zero

  while(1) {
    LATA = ~LATA;        // Invert PORTA value
    LATB = ~LATB;        // Invert PORTB value
    Delay_ms(1000);
  }
}