/*
 * Project name:
     Led_Curtain (The simplest simple example)
 * Copyright:
     (c) mikroElektronika, 2011.
 * Revision History:
     20110202:
       - Initial release (SZ);
 * Description:
     Simple "Hello world" example for the world of dsPIC MCUs;
 * Test configuration:
     MCU:             PIC24FJ16KA102
                      http://ww1.microchip.com/downloads/en/DeviceDoc/PIC24F16KA102_Family_datasheet_39927b.pdf
     Dev.Board:       Easy24-33 v6
                      http://www.mikroe.com/eng/products/view/494/easy24-33-v6-development-system/
     Oscillator:      HS, 8.00000 MHz
     Ext. Modules:    None.
     SW:              mikroC PRO for dsPIC30/33 and PIC24
                      http://www.mikroe.com/eng/products/view/231/mikroc-pro-for-dspic30-33-and-pic24/
 * NOTES:
     - Turn ON all PORT LEDs at SW4.
 */
 
int counter;

void wait() {
  Delay_ms(100);
}

void main() {

  AD1PCFG = 0x1C3F;      // Configure AN pins as digital I/O
  TRISA = 0;             // Set direction to be output
  TRISB = 0;             // Set direction to be output

  LATB = 0;              // Turn OFF the PORTB LEDs
  while (1) {
    for (counter = 0; counter < 8; counter++){
      LATA |= 0x0101 << counter;
      LATB |= 0x0101 << counter;
      wait();
    }

    counter = 0;
    while (counter < 8) {
      LATA &= ~(0x0101 << counter);
      LATB &= ~(0x0101 << counter);
      wait();
      counter++;
    }
  }
}