// Note: This library is strictly written for the Easy24-33v6 development board and its default MCU - PIC24FJ16KA102!

void CAPSense_Init(){
// CTMU settings
    CTMUEN_bit = 0;        // Disable CTMU
    CTMUSIDL_bit = 0;      // Continue module operation in Idle mode
    TGEN_bit = 0;          // Disable edge delay generation
    EDGEN_bit = 0;         // Edges are blocked
    EDGSEQEN_bit = 0;      // No edge sequence is needed
    IDISSEN_bit = 0;       // Analog current source output is not grounded
    CTTRIG_bit = 0;        // Trigger output is disabled

    EDG2POL_bit = 0;       // Edge 2 programmed for a negative edge response
    EDG2SEL_1_bit = 1;     // Edge 2 Source Select bits - CTED1 pin
    EDG2SEL_0_bit = 1;

    EDG1POL_bit = 1;       // Edge 1 programmed for a positive edge response
    EDG1SEL_1_bit = 1;     // Edge 2 Source Select bits - CTED1 pin
    EDG1SEL_0_bit = 1;

    CTMUICON = 0x300;      // CTMU CURRENT = 100  Base current(0.55 A nominal) = 55uA
    CTMUICON &= 0x03FF;
//

// ADC module settings
    AD1CON1 = 0x0000;
    AD1CSSL= 0x0000;
    FORM_1_bit = 0;        // Unsigned integer (0000 00dd dddd dddd)
    FORM_0_bit = 0;
    AD1CON3 = 0x0000;
    AD1CON2 = 0x0000;
    ADON_AD1CON1_bit = 1;
//
    CTMUEN_bit = 1;        // Enable CTMU
}



unsigned CAPSense_Read(unsigned cap_button){
    AD1PCFG = 0x01CF;
    TRISB &= 0xAFF0;
    LATB  &= 0xAFF0;
    PORTB &= 0xAFF0;
    Delay_us(1);

    switch (cap_button) {
          case 2 :  {TRISB0_bit = 1; break;}
          case 3 :  {TRISB1_bit = 1; break;}
          case 4 :  {TRISB2_bit = 1; break;}
          case 5 :  {TRISB3_bit = 1; break;}
          case 10 : {TRISB14_bit = 1; break;}
          case 12 : {TRISB12_bit = 1; break;}
         }

    AD1PCFG &= ~(1 << cap_button);     // ADC channel selection
    Delay_us(1);

    AD1CHS = cap_button;
    IDISSEN_bit  = 1;
    Delay_us(1);

    IDISSEN_bit = 0;
    AD1IF_bit   = 0;
    SAMP_AD1CON1_bit  = 1;
    EDG2STAT_bit = 0;
    EDG1STAT_bit = 1;


    Delay_us(3);                       // This delay determines the time constant T in the V = (Ictmu * T)/C equation!

    EDG1STAT_bit = 0;
    AD1IF_bit = 0;
    SAMP_AD1CON1_bit = 0;

    while(!AD1IF_bit);
    SAMP_AD1CON1_bit = 0;
    AD1IF_bit = 0;
    DONE_AD1CON1_bit = 0;

    return ADC1BUF0;                   // return the measured voltage V
}